// dflibg firefly
// copyright chrys garnant / chrysalis systems
// dflibg.org
// 
//    content script:
//    bridge between doc and extension daemon
//        extension daemon is bridge between context script and sdk

var xport = null;
var dflibgIsActive = 0;
var pathname = "";

window.addEventListener("message", function(event) {
    // screen msgs
    if (event.source != window)
        return;
    var msg = event.data;
    if (msg.msgsrc)
        {
        if (msg.msgsrc == "doc" || msg.msgsrc == "tab") 
            {
            switch (msg.msgdst)
              {
              case "daemon":                             // fwd msg to extension component...
              case "bkg":
              case "xtn":
              case "sdk": 
                          msg.msgpath = pathname;
                          if (xport)
                              xport.postMessage(msg);
                          break;
                                                         // msg to content script...
              case "scr": if (msg.msgtype == "activate")
                              {
                              dflibgIsActive = 1;
                              chrome.runtime.sendMessage( {msgtype: "activate", msgsrc:"scr", msgdst:"daemon"} );
                              }
                          else
                          if (msg.msgtype == "opensdk")
                              {
                              dflibgIsActive = 1;
                              chrome.runtime.sendMessage( {msgtype: "opensdk", msgsrc:"scr", msgdst:"daemon"} );
                              }
                              
                          console.log("msg dst=scr, msgtype="+msg.msgtype);
                          break;
              default:
                          break;
              }
            }
        }
    }, false);

window.addEventListener("unload", function(event) {
    xport.disconnect();
    xport = null;
    });



chrome.runtime.onConnect.addListener( function(port) { 
    var portname = "xtension";

    xport = port;  // port to content script

    xport.onMessage.addListener ( function(msg) 
        {                                               // msg from extension component...
        if (msg.msgdst)
            {
            switch (msg.msgdst) {
              case "daemon":
              case "bkg":
              case "xtn":
              case "sdk":                               // msg to extension component 
                      if (console)                      // illogical; should not occur
                          console.log("dflibg.scr> invalid inbound msg destination");
                      break;                            

              case "scr":                               // msg to content script
                      // if (pathname === "")
                          pathname = msg.msgpath;
                      if (msg.msgtype == "connect" && msg.msgsrc == "daemon")
                          {
                          if (dflibgIsActive == 1)
                              {
                              xport.postMessage({"msgtype":"accept", "msgsrc":"scr",
                                                 "msgdst":"daemon", "msgpath":pathname}, "*");
                              window.postMessage( { "protocol" : "xport",
                                                    "msgtype"  : "notify",
                                                    "msgdst"   : "lib",
                                                    "msgdata"  : { "protocol"  : "stream",
                                                                   "msgtype"   : "propagate",
                                                                   "msgstream" : "dflibg.extn",
                                                                   "msgdata"   : { "protocol" : "msgstream",
                                                                                   "msgtype"  : "extension_connected",
                                                                                   "msgdata"  : pathname }}}, "*" );
                              }
                          else
                              xport.postMessage({"msgtype":"reject", "msgsrc":"scr",
                                                 "msgdst":"daemon", "msgpath":pathname}, "*");
                          }
                      break;
                                                        // msg to document script
              case "lib":                               // or dflibg library
              case "tab":
              case "doc": window.postMessage(msg, "*");
                      break;
              default:
                      break;
              }
            }
        });

    xport.onDisconnect.addListener ( function()
        {
        xport=null;
        window.postMessage({"protocol" : "link", "msgtype":"disconnect", "msgsrc":"scr", "msgdst":"doc", "data":"disconnect"}, "*");
        });
    });
