// dflibg(tm) sdk/firefly miscellaneous utilities
// a) function source formatting
// b) cookie stuff (until dflibg.js fully supports
//                  node.source(name, DF_COOKIE)
//

function functiontrim(source, options) {
    var lines = source.split("\n");
    var prefixlength = 0;
    var prefixlengths = [];
    var firstposn;
    var isbracefound = false;
    var isbrace;
    var braceposn;
    var outlines= "";
    var outline;
    var splitline;
    var lineno;
    var line;
    var indentlevel;
    var indentation = "";
    var indent = 0;
    var splitposn;
    var nosplit;
    var isHTML = false;


    if (arguments.length > 1)
       isHTML = true;

    if (lines.length > 1)
        {
        for (lineno=0; lineno<lines.length && prefixlength == 0; lineno++)
            {
            line = lines[lineno];
            firstposn = line.search("[^ ]");

            if (!isbracefound)
                {
                braceposn = line.indexOf("{");
                if ( braceposn > -1)
                    {
                    isbracefound = true;
                    if (braceposn == firstposn)
                        {
                        if (firstposn > 4)
                             {
                             prefixlength = firstposn - 4;
                             line = lines[lineno].slice(prefixlength);
                             }
                        }
                    else
                    if (firstposn > 14)
                        line = lines[lineno].slice(firstposn-14);
                    }
                outline = (isHTML) ? neuterString(line) : line;
                } 
            else
            if (firstposn > 4)
                {
                prefixlength = firstposn - 4;
                line = lines[lineno].slice(prefixlength);
                outline = (isHTML) ? neuterString(line) : line;
                }
            else
                {
                outline = (isHTML) ? neuterString(line) : line;
                }
            outlines += String("0000" + lineno).slice(-4) + " " + outline + "\n";
            }

        prefixlengths.push(prefixlength);

        for (;lineno<lines.length; lineno++)
            {
            line = lines[lineno];
            firstposn = line.search("[^ ]");
            if (firstposn < prefixlength && firstposn > 4)
                {
                prefixlengths.push(prefixlength);
                prefixlength = firstposn;
                indent = firstposn;
                }
            else
            if (firstposn > prefixlength)
                {
                if (firstposn > prefixlengths[prefixlengths.length - 1])
                    {
                    if (prefixlengths.length > 1)
                        prefixlength = prefixlengths.pop();
                    else
                        prefixlength = prefixlengths[0];
                    }
                indent = firstposn - prefixlength;
                }

            
            if (indent > 0)
                {
                outline = (isHTML) ? neuterString(line.slice(prefixlength))
                                   : line.slice(prefixlength);
                }
            else
                outline = (isHTML) ? neuterString(line) : line;
    
            outlines += String("0000" + lineno).slice(-4) + " " + outline + "\n";
            }
        return outlines;
        }
    else
        return (isHTML) ? neuterString(source) : source;
    }
    
function splitLine(outline, indent, optwidth) {
    var nosplit = true;
    var splitposn = optwidth;
    var minposn   = splitposn / 2;
    var splitline;
    var indentation;
    var firstposn;
    var i;

    if (outline.length > optwidth)
        {
        indentation = "";
        for (i=0; i<indent; i++)
            indentation += " ";

        while (splitposn > 32 && nosplit)
            {
            if (outline[splitposn] == " ")
                {
                splitline = outline.substr(0, splitposn-1) + " \\ \n"+indentation+outline.substr(splitposn+1);
                nosplit = false;
                }
            splitposn--;
            }
        return splitline;
        }
    else
        return outline;
    }

function deriveExcerpt(src) {
    var converted;
    var ltposn;
    var gtposn;

    if (src.length > 40)
        {
        ltposn = src.indexOf("<");
        if (ltposn > -1 && ltposn < 25)
            {
            gtposn = src.indexOf(">");
            if (gtposn > (ltposn - -2) && gtposn < 25)
                {
                ltposn = src.lastIndexOf("<");
                if (ltposn > src.length - 12)
                    converted = src.substr(0,gtposn- -1)+ "..." + src.substring(ltposn);
                else
                    converted = src.substr(0,gtposn- -1)+ "..." + src.substring(src.length - 12);
                }
            else
                converted = src.substr(0,25) + "..." + src.substr(src.length-10);
            }
        else
            converted = src.substr(0,25) + "..." + src.substr(src.length-10);
        }
    else
        converted = src;
    return converted;
    }

var nsExp;
nsExp = new RegExp(/ /);

function neuterSpaces(src) {
    var i;
    var dequote;
    var dchar;
    var converted;
    var more;
    var line;

return src;

    converted = "";
    if (typeof src === "string")
        {
        /*
        line = src;
        more = true;
        while (more) {
            dequote = line.search("[ ]");
            if (dequote > -1)
                {
                converted += line.substr(0, dequote);
                dchar = line[dequote];
                if (dchar === " ")
                    converted += "&nbsp;"
                line = line.slice(dequote+1);
                if (line.length == 0)
                    more = false;
                }
            }
        */
        converted = src.replace(nsExp, "&nbsp;");
        return converted;
        }
    else
        return src;
    }


function neuterString(src, istrim) {
    var i;
    var dequote;
    var dchar;
    var converted;
    var more;
    var line;

    converted = "";
    if (typeof src === "string")
        {
        line = src;
        more = true;
        while (more) {
            dequote = line.search("[\"\'\&<>]");
            if (dequote > -1)
                {
                converted += line.substr(0, dequote);
                dchar = line[dequote];
                if (dchar === "\"")
                    converted += "&quot;";
                else
                    if (dchar === "\'")
                    converted += "&apos;";
                else
                    if (dchar === "\&")
                    converted += "&amp;";
                else
                if (dchar === "<")
                    converted += "&lt;";
                else
                if (dchar === ">")
                    converted += "&gt;";
                 
                line = line.slice(dequote+1);
                if (line.length == 0 )
                    more = false;
                }
            else
                {
                more = false;
                converted += line;
                }
            }
        if (arguments.length > 1)
            {
            if (istrim)
                {
                line = converted;
                converted = "";
                more = true;
                while (more)
                    {
                    dequote = line.search("\n\n");
                    if (dequote > -1)
                        {
                        converted += line.substr(0, dequote);
                        line = line.slice(dequote+1);
                        if (line.length == 0 )
                            more = false;
                        }
                    else
                        {
                        more = false;
                        converted += line;
                        }
                    }
                }
            }
        return converted;
        }
    else
        return src;
    // dflibg.log("conversion: "+converted);
    }

function htmlToString(source) {
    var lines = source.split("\n");
    var prefixlength = 0;
    var firstposn;
    var isbracefound = false;
    var isbrace;
    var braceposn;
    var outlines= "";
    var lineno;
    var line;
    var indentlevel;
    


    if (lines.length > 1)
        {
        for (lineno=0; lineno<lines.length && prefixlength == 0; lineno++)
            {
            line = lines[lineno];
            firstposn = line.search("[^ ]");

            if (!isbracefound)
                {
                braceposn = line.indexOf("{");
                if ( braceposn > -1)
                    {
                    isbracefound = true;
                    if (braceposn == firstposn)
                        {
                        if (firstposn > 4)
                             {
                             prefixlength = firstposn - 4;
                             line = lines[lineno].slice(prefixlength);
                             }
                        }
                    else
                    if (firstposn > 14)
                        line = lines[lineno].slice(firstposn-14);
                    }
                outlines += String("0000" + lineno).slice(-4) + " " + line + "\n";
                } 
            else
            if (firstposn > 4)
                {
                prefixlength = firstposn - 4;
                line = lines[lineno].slice(prefixlength);
                outlines += String("0000" + lineno).slice(-4) + " " + line + "\n";
                }
            else
                {
                outlines += String("0000" + lineno).slice(-4) + " " + line + "\n";
                }
            }
        for (;lineno<lines.length; lineno++)
            {
            line = lines[lineno];
            firstposn = line.search("[^ ]");
            if (firstposn > prefixlength)
                outlines += String("0000" + lineno).slice(-4) + " " + line.slice(prefixlength) + "\n";
            else
                outlines += String("0000" + lineno).slice(-4) + " " + line + "\n";
            }
        return outlines;
        }
    else
        return source;
    }
    
function functionargs(source) {
    var argstart;
    var argend;
    var arglist;
    var args;
    var i;


    argstart = source.indexOf("(");
    argend   = source.indexOf(")", argstart);

    arglist    = source.substring(argstart, argend).trim();
    args = arglist.split(",");
    for (i=0; i<args.length; i++)
        args[i] = args[i].trim;
    return args;
    }

function functionargIlist(args) {
    var arglist = "(";
    var i;
    for (i=0; i<args.length; i++)
        arglist += (i==0) ? "arg0" : ", arg"+i;
           
    arglist += ")";
    return arglist;
    }
    
function functionarglist(args) {
    var arglist = "(";
    var i;
    for (i=0; i<args.length; i++)
        arglist += (i==0) ? args[i] : ", "+args[i];
           
    arglist += ")";
    return arglist;
    }

// -------------------------------------------------------------
// dfirefly & demerald cookie stuff
    
function dfsetCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires;
}

function dfgetCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}

//
function dfselectNode(event) {
    alert ('right');
    event.preventDefault();
    if ('bubbles' in event)
        event.stopPropagation();
    else
        event.cancelBubble = true;
    }
