// dflibg(tm) navPageServer module
// (c)Chrys Garnant / Chrysalis Systems
// 

function navPageServer() {
    nbuttonOnClick     = new node("buttonOnClick", "", null, DF_INJECTOR);

    nnavigateButton    = nbuttonOnClick.epilogue( function(button) {
                                 return (button.className == "navbutton") ? button : null;
                                 });
    nnavigateButton.ioctrl(DF_ONVALID);

    mnavigateMenuCell  = nbuttonOnClick.epilogue( function(button) {
                                 var menudata = null;
                                 var menucell = null;
                                 var pagegroup = "pagegroup";
                                 var menubar;
                                 var cellclass = "menucell";

                                 if (button.className !== "navbutton")
                                     {
                                     menubar = dfsdk.findDOMRoot(button, "menubar");
                                     if (menubar)
                                         {
                                         if (menubar.hasAttribute("data-pagegroup"))
                                             pagegroup = menubar.getAttribute("data-pagegroup");
                                         if (menubar.hasAttribute("data-menucell"))
                                             cellclass = menubar.getAttribute("data-menucell");
                                         menucell = dfsdk.findDOMAncestor(button, "menubar", cellclass)
                                         if (menucell)
                                             {
                                             menudata = new Object();
                                             menudata.button  = menucell;
                                             menudata.target  = button;
                                             menudata.menubar = menubar;
                                             menudata.pagegroup = document.getElementById(pagegroup);
                                             }
                                         }
                                     }
                                 return menudata;
                                 });
    mnavigateMenuCell.ioctrl(DF_ONVALID);

                                 // -------------------------------------------------------------
                                 // navigate by menu cell selection (merges tabbar w/ navbar)
                                 // -------------------------------------------------------------
  
    mpageSet           = new node("mpageSet", null, function(menudata) {
                                 var pageSet = dfsdk.findDOMDescendant(menudata.pagegroup, "pageset");
                                 return (pageSet) ? pageSet.children : null;
                                 }, DF_ASYNC);
    mpageSet.bind(mnavigateMenuCell);
    mpageSet.ioctrl(DF_ONVALID);

    mpageSelect0       = new node("mpageSelect0", null, function(menudata, pageSet) {
                                 var pageno;
                                 var pageid;
                                 var pageSpec = null;
                                 
                                 if (menudata.button.hasAttribute("data-pagenumber"))
                                     {
                                     pageno = menudata.button.getAttribute("data-pagenumber");
                                     if (pageno > -1 && pageno < pageSet.length)
                                         {
                                         pageSpec = { "page" : pageSet[pageno],
                                                      "pageno" : pageno };
                                         }
                                     }
                                 else
                                 if (menudata.button.hasAttribute("data-pageid"))
                                     {
                                     pageid = menudata.button.getAttribute("data-pageid");
                                     for (pageno=0; pageno<pageSet.length && pageSpec === null; pageno++) {
                                         if (pageSet[pageno].id === pageid)
                                             {
                                             pageSpec = { "page" : pageSet[pageno],
                                                          "pageno" : pageno };
                                             }
                                         }
                                     }
                                 return pageSpec;
                                 }, DF_SYNC);
    mpageSelect0.bind(mnavigateMenuCell, mpageSet)
    mpageSelect0.ioctrl(DF_ONVALID);

    mpageSelect = mpageSelect0.epilogue('$0.page');
    mpagePageNo = mpageSelect0.epilogue('$0.pageno');

    mpageCurrent       = new node("mpageCurrent", null, function(pageSet) {
                                 var currentpage = null;
                                 var i;
                                 for (i=0; i<pageSet.length && currentpage === null; i++) {
                                     if (pageSet[i].offsetParent !== null)
                                         currentpage = pageSet[i];
                                     }
                                 return currentpage;
                                 }, DF_ASYNC);
    mpageCurrent.bind(mpageSet);
    mpageCurrent.ioctrl(DF_ONVALID);
                  
                                  

                                 // -------------------------------------------------------------
                                 // navigate by button [first][back][next][last]...
                                 // -------------------------------------------------------------
  
    nnavigate          = nnavigateButton.epilogue( '$0.value' );

    nnavbarLabel       = nnavigateButton.epilogue( function(button) {
                                 return dfsdk.findDOMCousin(button, "navbar", "navlabel");
                                 });

    npageSet           = new node("pageSet", null, function(button) {
                                 var pageSet;
                                 
                                 pageSet = dfsdk.findDOMCousin(button, "pagegroup", "pageset");
                                 if (pageSet)
                                     return (pageSet.children);
                                 else
                                     return null;
                                 }, DF_ASYNC);
    npageSet.bind(nnavigateButton);
    npageSet.ioctrl(DF_ONVALID);

    ncurrentPageno     = npageSet.epilogue( function(pageSet) {
                                 var currentpageNo = -1;
                                 var i;
                                 for (i=0; i<pageSet.length && currentpageNo === -1; i++)
                                     {
                                     if (pageSet[i].offsetParent !== null)
                                         currentpageNo = i;
                                     }
                                 return currentpageNo;
                                 });
    ncurrentPage       = new node("pageCurrent", null, function(pageSet, pageno) {
                                  return (pageno > -1) ? pageSet[pageno] : null;
                                  }, DF_SYNC);
    ncurrentPage.bind(npageSet, ncurrentPageno);


    nbuttonSet         = nnavigateButton.epilogue(
                             function(button) {
                                 var buttonGroup = new Object;
                                 buttonGroup.first = null;
                                 buttonGroup.prev  = null;
                                 buttonGroup.next  = null;
                                 buttonGroup.last  = null;
 
                                 var buttonBar = button.parentNode;
                                 var buttons = buttonBar.children;
                                 var navbutton;
                                 var i;
                                 for (i=0; i<buttons.length; i++)
                                     {
                                     navbutton = buttons[i];
                                     if (navbutton.className == "navbutton")
                                         { // extraneous (non-button elements) filtered out
                                         switch (navbutton.value)
                                           {
                                           case "first": buttonGroup.first = navbutton;
                                                         break;
                                           case "prev":  buttonGroup.prev = navbutton;
                                                         break;
                                           case "next":  buttonGroup.next = navbutton;
                                                         break;
                                           case "last":  buttonGroup.last = navbutton;
                                                         break;
                                           }
                                         }
                                     }

                                 return buttonGroup;
                                 });
    nbuttonFirst       = nbuttonSet.epilogue("$0.first");
    nbuttonPrev        = nbuttonSet.epilogue("$0.prev");
    nbuttonNext        = nbuttonSet.epilogue("$0.next");
    nbuttonLast        = nbuttonSet.epilogue("$0.last");

 
    nnextPageNo        = new node("nextpageno", null, function(pageSet, currentpageno, navigate) {
                                  var pageno = -1;
                                  switch (navigate) {
                                    case "first": pageno = 0; break;
                                    case "prev":  pageno = (currentpageno > 0) ? 
                                                               currentpageno - 1 : 0;
                                                  break;
                                    case "next":  pageno = (currentpageno < (pageSet.length - 1)) ?
                                                               currentpageno + 1 : pageSet.length - 1;
                                                  break;
                                    case "last":  pageno = pageSet.length - 1; break;
                                    }
                                  return pageno; 
                                  }, DF_SYNC);
    nnextPageNo.bind(npageSet, ncurrentPageno, nnavigate);
    nnextPageNo.ioctrl(DF_ONPOSITIVE);

    npageNext          = new node("pageNext", null, function(pageno, currentpageno, pageSet) {
                                  var pageNext = null;
                                  if (pageno !== currentpageno)
                                      pageNext = pageSet[pageno];
                                  return pageNext;
                                  }, DF_SYNC);
    npageNext.bind(nnextPageNo, ncurrentPageno, npageSet);
    npageNext.ioctrl(DF_ONVALID);

    // hide old page
    ncurrentPageMUX    = new node("currentPageMUX", null, DF_MUX);
    ncurrentPageMUX.bind(ncurrentPage, mpageCurrent);

    nhidePage          = ncurrentPageMUX.epilogue( "none" );
    nhidePage.attach(ncurrentPageMUX);
    nhidePage.attachment("STYLE", "display");

    // display new page
    nshowPageMUX       = new node("showPageMUX", null, DF_MUX);
    nshowPageMUX.bind(npageNext, mpageSelect);

    nshowPage          = nshowPageMUX.epilogue( "block" );
    nshowPage.attach(nshowPageMUX);
    nshowPage.attachment("STYLE", "display");

    // update navbar label
    nshowLabel         = new node ("showLabel", "", function(page) {
                                  var element = null; 
                                  var label = "";

                                  element = dfsdk.findDOMDescendant(page, "pagelabel")
                                  if (element)    
                                      label = element.innerHTML;
                                  return label;
                                  }, DF_ASYNC);

    nshowLabel.bind(nshowPageMUX);
    nshowLabel.attach(nnavbarLabel);

    // update enable/disable buttons --------------------------------------------------------
    //

    nnextPageNoMUX      = new node("nextPageNoMUX", 0, DF_MUX);
    nnextPageNoMUX.bind(nnextPageNo, mpagePageNo);

    nenableFirst        = new node("enableFirst", null, 
                                  function(pageno) {
                                      return (pageno > 0) ? "" : "disabled";
                                      }, DF_ASYNC);                              
    nenableFirst.bind(nnextPageNoMUX);
    nenableFirst.attach(nbuttonFirst, nbuttonPrev);
    nenableFirst.attachment("disabled");

    nenableLast        = new node("enableLast", null, 
                                  function(pageno, pageSet) {
                                      return (pageno < (pageSet.length - 1)) ? "" : "disabled";
                                      }, DF_SYNC);                              
    nenableLast.bind(nnextPageNoMUX, npageSet);
    nenableLast.attach(nbuttonLast, nbuttonNext);
    nenableLast.attachment("disabled");

    // utility functions:
    function findDescendant(section, classtag)
                 {
                 var subsections = section.children;
                 var element = null;
                 var i;
                 for (i=0; i<subsections.length && element === null; i++)
                     {
                     if (subsections[i].className === classtag)
                         element = subsections[i];
                     else
                         element = findDescendant(subsections[i], classtag);
                     }
                 return element;
                 };

    function findCousin(section, roottag, classtag)
                 {
                 var container = section.parentNode;
                 var root = null;
                 var cousin = null;

                 while (container && root === null)
                     {
                     if (container.className == roottag)
                          root = container;
                     else
                          container = container.parentNode;
                     }

                 if (root)
                     cousin = findDescendant(root, classtag);
                 return cousin;
                 };
    };
