// dflibg(tm) sdk/firefly options module
// (c)Chrys Garnant / Chrysalis Systems
// 
// dependencies: dfirefly0.js

function sdkOptions() {
    nopenOptionsPage    = new node("openOptionsPage", "", DF_INJECTOR);
    nopenOptionsPage.source('openPreferences', 'click', '.event');
    nopenOptionsPageGo  = nopenOptionsPage.epilogue( function(event) {
                                 popup('popUpDiv');
                                 });

    ncloseOptionsPage   = new node("closeOptionsPage", "", DF_INJECTOR);
    ncloseOptionsPage.source('closeHint', 'click', '.event');
    ncloseOptionsPage.source('overviewOptionsCancel', '.click', '.event');
    ncloseOptionsPage.ioctrl(DF_ONESHOT);
   
    ncloseOptionsPageGo = ncloseOptionsPage.epilogue( function(event) {
                                 unpop('popUpDiv');
                                 });

                         // ------------------------------- load options
                         //

    nloadOptionsPage    = new node("loadOptionsPage", "", function(now) {
                                 var options = {};
                                 var isskip;
                                 isskip = dfgetCookie("dfirefly_skipWelcome");
                                 options.isSkipWelcome  = ( isskip === "true") ? true : false;

                                 isskip = dfgetCookie("dfirefly_skipOverview");
                                 options.isSkipOverview = ( isskip === "true") ? true : false;
                                 return options;
                                 }, DF_EVENT);
    nloadOptionsPage.bind(nopenOptionsPage);

    nloadOptionsSkipWelcome = nloadOptionsPage.epilogue('$0.isSkipWelcome');
    nloadOptionsSkipWelcome.attach('skipWelcomeCBOX');
    nloadOptionsSkipWelcome.attachment('checked');

    nloadOptionsSkipOverview = nloadOptionsPage.epilogue('$0.isSkipOverview');
    nloadOptionsSkipOverview.attach('skipOverviewCBOX');
    nloadOptionsSkipOverview.attachment('checked');

                         // ------------------------------- options processing
                         // cookies ???

    nisSkipWelcome      = new node("isSkipWelcome",  false, DF_MUX);
    nisSkipWelcome.bind(nloadOptionsSkipWelcome);
    nisSkipOverview     = new node("isSkipOverview", false, DF_MUX);
    nisSkipOverview.bind(nloadOptionsSkipOverview);


    noptSkipWelcome     = new node("optSkipWelcome", false, DF_INJECTOR);
    noptSkipWelcome.source('skipWelcomeCBOX');
    noptSkipOverviews   = new node("optSkipOverview", false, DF_INJECTOR);
    noptSkipOverviews.source('skipOverviewsCBOX');

    napplySkipOptions   = new node("applySkipOptions", "", DF_INJECTOR);
    napplySkipOptions.source('overviewOptionsApply');
    napplySkipOptions.ioctrl(DF_ONESHOT);

    napplySkipClose     = napplySkipOptions.epilogue( function (now) {
                                 unpop('popUpDiv');
                                 });

                        // save cookies for options...
                        // save current state
                        
    napplySkipWelcome   = napplySkipOptions.epilogue( function (now, isskip) {
                             dfsetCookie("dfirefly_skipWelcome", (isskip) ? "true" : "false", 365);
                             return isskip;
                             }, noptSkipWelcome);
    nisSkipWelcome.bind(napplySkipWelcome);

    napplySkipOverview  = napplySkipOptions.epilogue( function (now, isskip) {
                             dfsetCookie("dfirefly_skipOverview", (isskip) ? "true" : "false", 365);
                             return isskip;
                             }, noptSkipOverviews);
    nisSkipOverview.bind(napplySkipOverview);

                        // apply changes or reinstate original state to display...
                        // 
                        //  welcome overview introduction versus start page introduction
                        //
    nisWelcomeSkip      = new node('isWelcomeSkip', false,
                          function(apply, reinstate, newstate, oldstate) {
                             var why = this.eventID();
                             return (why == 0 || why == 2) ? newstate : oldstate;
                             }, DF_ASYNC);
    nisWelcomeSkip.bind(napplySkipOptions, ncloseOptionsPage, noptSkipWelcome, nisSkipWelcome);
    nisWelcomeSkip.ioctrl(DF_ONCHANGE);

    ndisableWelcome     = new node("disableWelcome", "", function(isskip) {
                             return (isskip) ? "none" : "block";
                             }, DF_ASYNC);
    ndisableWelcome.bind(nisWelcomeSkip);
    ndisableWelcome.attach('wkoverviewMenu', 'overviewWK');
    ndisableWelcome.attachment("STYLE", "display");

    nenableWelcome     = new node("enableWelcome", "", function(isskip) {
                             return (isskip) ? "block" : "none";
                             }, DF_ASYNC);
    nenableWelcome.bind(nisWelcomeSkip);
    nenableWelcome.attach('wkintroMenu', 'introWK');
    nenableWelcome.attachment("STYLE", "display");


                        //  individual tool overview page(s) versus individual tool start page
                        //
    nisOverviewSkip      = new node('isOverviewSkip', false,
                          function(apply, reinstate, newstate, oldstate) {
                             var why = this.eventID();
                             return (why == 0 || why == 2) ? newstate : oldstate;
                             }, DF_ASYNC);
    nisOverviewSkip.bind(napplySkipOptions, ncloseOptionsPage, noptSkipOverviews, nisSkipOverview);
    nisOverviewSkip.ioctrl(DF_ONCHANGE);
    nisOverviewSkip.export();


                        // dataflow strategies, either
                        // a) attach everything here, OR
                        // b) add a small dfe to each page module which hooks
                        //    to nisOverviewSkip AND to the tabPageServer output
                        //    nisOverviewSkip - to determine its startup mode
                        //    tabPageServer.xxxx - to compare against to see if itself is being activated
                        // ??? method tbd
                        // -> b) is probably better re coupling as this module does not need to
                        //       know WHO to activate/deactivate, while menu items, which subpages, etc.,
                        //       those are then the purview of the dfe/module FOR THAT PAGE/FEATURE
                       
    ndisableOverview     = new node("disableOverview", "", function(isskip) {
                             return (isskip) ? "none" : "block";
                             }, DF_ASYNC);
    ndisableOverview.bind(nisOverviewSkip);

    nenableOverview     = new node("enableOverview", "", function(isskip) {
                             return (isskip) ? "block" : "none";
                             }, DF_ASYNC);
    nenableOverview.bind(nisOverviewSkip);

                        // now load and apply options...
    nloadOptionsPage.fire();
    };


