/* dfcom.tabpageServer
 * copyright Chrysalis Systems
 * see www.dflibg.org for full copyright notice 
 * and license
 */
                             // this version of tagPageServer ALSO allows for selection of a tab
                             // by something other than an item in the tabbar set of tab buttons
                             // ie:    modulep.inject(tabname);

function tabPageServer() {
  "use strict";
    var ntabOnClick, ntabSelection, ntabNewTab, ntabActiveTab, ntabActiveDiv, ntabNewDiv, ntabSelected;
    var ntabDeactivateTab, ntabDeactivateDiv, ntabActivateTab, ntabActivateDiv, ntabSelectionEX;
    var nselectedPage;

    ntabOnClick        = new node("tabOnClick", "", null, DF_INJECTOR);

    ntabSelection      = new node("tabSelection", "", function(elementSpec) {
                             var baseclassname    = "tab";
                             var activeclassname  = "tabselected";
                             var pageset          = "";
                             var tabselection     = null;
                             var tab    = null;
                             var tabbar = null;
                             var container = null;
                             var parent    = null;
                             var element   = null;
          
                             if (typeof elementSpec === "string")       // select by tabname
                                 element = document.getElementById(elementSpec);
                             else
                                 element = elementSpec;                 // select by click on HTMLElement

                             if (element)
                                 parent = element.parentNode;
                             else
                                 return null;

                             while (parent && (tabbar == null))
                                 {
                                 if (parent.className)
                                     {
                                     if (parent.className == "tabgroup")
                                         tabbar = parent;
                                     else
                                         parent = parent.parentNode;
                                     }
                                 else
                                     parent = parent.parentNode;
                                 }

                             if (tabbar)
                                 {
                                 if ( tabbar.hasAttribute("data-tabstyle"))
                                     {
                                     baseclassname = tabbar.getAttribute("data-tabstyle");
                                     if (tabbar.hasAttribute("data-tabselected"))
                                         activeclassname = tabbar.getAttribute("data-tabselected");
                                     else
                                         activeclassname = baseclassname+"selected";
                                     }
                                 if ( tabbar.hasAttribute("data-tabgroup"))
                                     pageset = tabbar.getAttribute("data-tabgroup");   // "" or "id" or "parent"/"siblings"

                                 container = element;
                                 while (container != tabbar && tab == null)
                                     {
                                     if (container.className)
                                         {
                                         if (container.className == baseclassname)
                                             tab = container;
                                         else
                                             container = container.parentNode;
                                         }
                                     else
                                         container = container.parentNode;
                                     }

                                 if (tab)
                                     {
                                     tabselection = new Object;
                                     tabselection.tabbar  = tabbar;
                                     tabselection.pageset = pageset;
                                     tabselection.element = tab;
                                     tabselection.baseclassname = baseclassname;
                                     tabselection.activeclassname = activeclassname;
                                     }
                                 }
                             return tabselection;
                             }, DF_ASYNC);

    ntabSelection.bind(ntabOnClick);
    ntabSelection.ioctrl(DF_ONVALID);

    ntabNewTab        = ntabSelection.epilogue ("$0.element");

    ntabNewDiv        = ntabNewTab.epilogue( function(element) {
                             if (typeof(element.value) == "string")
                                 return element.value;
                             else
                             if (element.hasAttribute('data-tabid'))
                                 return element.getAttribute('data-tabid');
                             else
                                 return element.id+"Div";
                             });

    nselectedPage     = new node(DF_PARAMETER);
    nselectedPage.source(ntabNewDiv, DF_ONDEMAND, ".target");

    ntabActiveTab     = ntabSelection.epilogue( function(tabselection) {
                             var activetab = null;

                             if (tabselection.element)
                                 {
                                 activetab = dfsdk.findDOMCousin(tabselection.element, "tabgroup",
                                                                 tabselection.activeclassname);                                    
                                 }
                             return activetab;
                             });
    // ntabActiveTab.ioctrl(DF_ONVALID);

    ntabDeactivateTab = new node ("tabDeactivateTab", "tab", function (tabselection, activetab) {
                                   return tabselection.baseclassname;
                                 }, DF_SYNC);
    ntabDeactivateTab.bind(ntabSelection, ntabActiveTab);
    ntabDeactivateTab.attach(ntabActiveTab);
    ntabDeactivateTab.attachment("CLASS");

    ntabActiveDiv     = new node('tabActiveDiv', "", function (activetab, tabselection, selectedPage) {
                             var activePage = "";
                             var activePages = [];
                             var pageGroup;
                             var siblings;
                             var sibling;
                             var i;

                             if (this.eventid == 0)                        // activetab dataevent
                                 {
                                 if (tabselection.pageset == "" && activetab != null)
                                     {                                     // not necessarily same parent (but should be?)
                                     if (typeof(activetab.value) == "string")
                                         activePage = activetab.value;
                                     else
                                     if (activetab.hasAttribute('data-tabid'))
                                         activePage = activetab.getAttribute('data-tabid');
                                     else
                                         activePage = activetab.id+"Div";
                                     return activePage;
                                     }
                                 else
                                 if (tabselection.pageset == "parent" || tabselection.pageset == "siblings")
                                     {
                                     pageGroup = selectedPage.parentNode;
                                     siblings = pageGroup.children;
                                     for (i=0; i<siblings.length; i++)
                                         {
                                         sibling = siblings[i];
                                         if (sibling.offsetParent != null)
                                             activePages.push(sibling)
                                         else
                                         if (sibling.style.display != "none")
                                             activePages.push(sibling)
                                         }
                                     return activePages;                   // hide all visible siblings
                                     }
                                 else
                                     return null;
                                 }
                             else
                                 return null;
                             }, DF_ASYNC, ntabActiveTab, ntabSelection, nselectedPage);

    ntabDeactivateDiv = ntabActiveDiv.epilogue( function () { return "none"; });
    ntabDeactivateDiv.attach(ntabActiveDiv);    // attach works with a connector referencing either an ID or an HTMLElement or an array of...
    ntabDeactivateDiv.attachment("STYLE", "display");

    ntabActivateTab   = new node("tabActivateTab", "tabselected", function(tabselection, element) {
                             return tabselection.activeclassname;
                             }, DF_SYNC);
    ntabActivateTab.bind(ntabSelection, ntabNewTab);
    ntabActivateTab.attach(ntabNewTab);
    ntabActivateTab.attachment("CLASS");
    
    ntabActivateDiv   = new node('tabActivateDiv', "block", function() {
                             return "block";
                             }, DF_ASYNC, ntabDeactivateDiv); // race condition/ must be after deactivate! //ntabNewDiv);
    ntabActivateDiv.attach(ntabNewDiv);
    ntabActivateDiv.attachment("STYLE", "display");

    ntabSelected       = new node('tabSelected', null, function(tab) {
                             return tab;
                             }, DF_ASYNC);
    ntabSelected.bind(ntabNewTab);
    this.export(ntabSelected);

    ntabSelectionEX    = ntabSelection.epilogue( function(selection) {
                             var tabselect = { "elementID"     : (selection.element.id) ? selection.element.id : "",
                                               "tabbarID"      : (selection.tabbar.id)  ? selection.tabbar.id : ""  };
                             return tabselect;
                             });
    ntabSelectionEX.client(dflibg.mystream, DF_CONNECT, 'tabselected');
    }
                          
